&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------

  File: parsetree.w

  Description: Display parsed source in treeview

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: Carl Verbiest (based upon tokenlister.p by John Green)

  Created: April 9, 2005
                    
  Issues, ideas, to do
  * keeps all nodes allocated, may be a problem on large sources
  * allocates too many nodes e.g. root is node 1, first node is 3
  * resizable window
  * images for nodes
  * build the tree as you click (I'm not sure if it's worth the trouble)
  * fill node temp-table to improve editor highlighting
  * improve variable naming, there are 3 types of node id in the source, can be confusing
  * mru lists for source and runcode
  
 ------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

 CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */
DEFINE VARIABLE firstnode       AS INTEGER   NO-UNDO.
DEFINE VARIABLE grandchild      AS INTEGER   NO-UNDO.
DEFINE VARIABLE showColumn      AS LOGICAL   NO-UNDO INITIAL TRUE.
DEFINE VARIABLE showDirectives  AS LOGICAL   NO-UNDO INITIAL TRUE.
DEFINE VARIABLE showFile        AS LOGICAL   NO-UNDO INITIAL TRUE.
DEFINE VARIABLE showLine        AS LOGICAL   NO-UNDO INITIAL TRUE.
DEFINE VARIABLE showState2      AS LOGICAL   NO-UNDO INITIAL TRUE.
DEFINE VARIABLE showStatehead   AS LOGICAL   NO-UNDO INITIAL TRUE.
DEFINE VARIABLE showStoretype   AS LOGICAL   NO-UNDO INITIAL TRUE.
DEFINE VARIABLE showWindow      AS LOGICAL   NO-UNDO INITIAL TRUE.
DEFINE VARIABLE NodeCount AS INTEGER    NO-UNDO.
DEFINE VARIABLE currentNode AS INTEGER    NO-UNDO.
DEFINE VARIABLE currentNodeCount AS INTEGER    NO-UNDO.
DEFINE VARIABLE parser AS HANDLE NO-UNDO.
DEFINE VARIABLE chCFTreeViewNodes AS COM-HANDLE NO-UNDO.
DEFINE VARIABLE currentSource AS CHARACTER  NO-UNDO.
DEFINE VARIABLE currentLine AS INTEGER    NO-UNDO.

DEFINE TEMP-TABLE tNode NO-UNDO
    FIELD atNode AS INTEGER
    FIELD atNodeCount AS INTEGER
    FIELD nodeStartRow AS INTEGER
    FIELD nodeStartColumn AS INTEGER
    FIELD nodeEndRow AS INTEGER
    FIELD nodeEndColumn AS INTEGER
    INDEX Node IS UNIQUE atNodeCount
    .

DEFINE TEMP-TABLE tAttrValue NO-UNDO
    FIELD atNode AS INTEGER
    FIELD atNodeCount AS INTEGER
    FIELD atName AS CHARACTER FORMAT "x(20)"
    FIELD atLabel AS CHARACTER FORMAT "x(20)"
    FIELD atValue AS CHARACTER FORMAT "x(255)"
    FIELD atFunction AS CHARACTER FORMAT "x(40)"
    FIELD atVisible AS LOGICAL INITIAL TRUE
    INDEX Node IS UNIQUE atNodeCount atName
    .

RUN proparse/api/proparse.p PERSISTENT SET parser.
{ proparse/api/proparse.i parser }

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME DEFAULT-FRAME
&Scoped-define BROWSE-NAME attrBrowse

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES tAttrValue

/* Definitions for BROWSE attrBrowse                                    */
&Scoped-define FIELDS-IN-QUERY-attrBrowse tAttrValue.atLabel tAttrValue.atValue tAttrValue.atFunction   
&Scoped-define ENABLED-FIELDS-IN-QUERY-attrBrowse   
&Scoped-define SELF-NAME attrBrowse
&Scoped-define QUERY-STRING-attrBrowse FOR EACH tAttrValue WHERE tAttrValue.atNodeCount = currentNodeCount AND tAttrValue.atVisible
&Scoped-define OPEN-QUERY-attrBrowse OPEN QUERY {&SELF-NAME} FOR EACH tAttrValue WHERE tAttrValue.atNodeCount = currentNodeCount AND tAttrValue.atVisible.
&Scoped-define TABLES-IN-QUERY-attrBrowse tAttrValue
&Scoped-define FIRST-TABLE-IN-QUERY-attrBrowse tAttrValue


/* Definitions for FRAME DEFAULT-FRAME                                  */
&Scoped-define OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME ~
    ~{&OPEN-QUERY-attrBrowse}

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS sourceFile bParse keepNodes attrBrowse ~
sourceEditor 
&Scoped-Define DISPLAYED-OBJECTS sourceFile keepNodes nodeProcedure ~
sourceEditor 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of handles for OCX Containers                            */
DEFINE VARIABLE CFImageList AS WIDGET-HANDLE NO-UNDO.
DEFINE VARIABLE chCFImageList AS COMPONENT-HANDLE NO-UNDO.
DEFINE VARIABLE CFTreeView AS WIDGET-HANDLE NO-UNDO.
DEFINE VARIABLE chCFTreeView AS COMPONENT-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON bParse 
     LABEL "Parse" 
     SIZE 12 BY 1.

DEFINE BUTTON bRunNodeProc 
     LABEL "Run code" 
     SIZE 14.2 BY 1.

DEFINE VARIABLE sourceEditor AS CHARACTER 
     VIEW-AS EDITOR NO-WORD-WRAP SCROLLBAR-HORIZONTAL SCROLLBAR-VERTICAL LARGE
     SIZE 88.2 BY 15.24 NO-UNDO.

DEFINE VARIABLE nodeProcedure AS CHARACTER FORMAT "X(256)":U INITIAL "proparse/utilities/nodemessage.p" 
     VIEW-AS FILL-IN 
     SIZE 70.8 BY 1 TOOLTIP "procedures gets 2 inputs: handle parser and integer theNode" NO-UNDO.

DEFINE VARIABLE sourceFile AS CHARACTER FORMAT "X(256)":U INITIAL "proparse/utilities/nodemessage.p" 
     VIEW-AS FILL-IN 
     SIZE 48 BY 1 NO-UNDO.

DEFINE VARIABLE keepNodes AS LOGICAL INITIAL yes 
     LABEL "Keep nodes allocated" 
     VIEW-AS TOGGLE-BOX
     SIZE 33.8 BY 1 TOOLTIP "run code requires the nodes to remain allocated" NO-UNDO.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY attrBrowse FOR 
      tAttrValue SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE attrBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS attrBrowse C-Win _FREEFORM
  QUERY attrBrowse DISPLAY
      tAttrValue.atLabel
tAttrValue.atValue
tAttrValue.atFunction
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS SIZE 88.2 BY 5.91
         FONT 0 FIT-LAST-COLUMN TOOLTIP "Double click browse to copy function to clipboard".


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     sourceFile AT ROW 1.1 COL 3 NO-LABEL
     bParse AT ROW 1.1 COL 52
     keepNodes AT ROW 1.1 COL 65.2
     nodeProcedure AT ROW 2.38 COL 60.2 NO-LABEL
     bRunNodeProc AT ROW 2.38 COL 133
     attrBrowse AT ROW 3.52 COL 59.8
     sourceEditor AT ROW 9.81 COL 59.8 NO-LABEL
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 147.4 BY 24.19
         FONT 0.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "Proparse treeview"
         HEIGHT             = 24.19
         WIDTH              = 147.4
         MAX-HEIGHT         = 24.19
         MAX-WIDTH          = 147.4
         VIRTUAL-HEIGHT     = 24.19
         VIRTUAL-WIDTH      = 147.4
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
                                                                        */
/* BROWSE-TAB attrBrowse bRunNodeProc DEFAULT-FRAME */
/* SETTINGS FOR BUTTON bRunNodeProc IN FRAME DEFAULT-FRAME
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN nodeProcedure IN FRAME DEFAULT-FRAME
   NO-ENABLE ALIGN-L                                                    */
/* SETTINGS FOR FILL-IN sourceFile IN FRAME DEFAULT-FRAME
   ALIGN-L                                                              */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE attrBrowse
/* Query rebuild information for BROWSE attrBrowse
     _START_FREEFORM
OPEN QUERY {&SELF-NAME} FOR EACH tAttrValue WHERE tAttrValue.atNodeCount = currentNodeCount AND tAttrValue.atVisible.
     _END_FREEFORM
     _Query            is OPENED
*/  /* BROWSE attrBrowse */
&ANALYZE-RESUME

 


/* **********************  Create OCX Containers  ********************** */

&ANALYZE-SUSPEND _CREATE-DYNAMIC

&IF "{&OPSYS}" = "WIN32":U AND "{&WINDOW-SYSTEM}" NE "TTY":U &THEN

CREATE CONTROL-FRAME CFTreeView ASSIGN
       FRAME           = FRAME DEFAULT-FRAME:HANDLE
       ROW             = 2.38
       COLUMN          = 1
       HEIGHT          = 22.62
       WIDTH           = 58
       HIDDEN          = no
       SENSITIVE       = yes.

CREATE CONTROL-FRAME CFImageList ASSIGN
       FRAME           = FRAME DEFAULT-FRAME:HANDLE
       ROW             = 9.1
       COLUMN          = 3
       HEIGHT          = 1.48
       WIDTH           = 5.4
       HIDDEN          = yes
       SENSITIVE       = yes.
      CFTreeView:NAME = "CFTreeView":U .
/* CFTreeView OCXINFO:CREATE-CONTROL from: {0713E8A2-850A-101B-AFC0-4210102A8DA7} type: TreeView */
      CFImageList:NAME = "CFImageList":U .
/* CFImageList OCXINFO:CREATE-CONTROL from: {58DA8D8F-9D6A-101B-AFC0-4210102A8DA7} type: ImageList */
      CFTreeView:MOVE-AFTER(keepNodes:HANDLE IN FRAME DEFAULT-FRAME).
      CFImageList:MOVE-AFTER(attrBrowse:HANDLE IN FRAME DEFAULT-FRAME).

&ENDIF

&ANALYZE-RESUME /* End of _CREATE-DYNAMIC */


/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* Proparse treeview */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* Proparse treeview */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME attrBrowse
&Scoped-define SELF-NAME attrBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL attrBrowse C-Win
ON MOUSE-SELECT-DBLCLICK OF attrBrowse IN FRAME DEFAULT-FRAME
DO:
  OUTPUT TO "clipboard":U.
  PUT UNFORMATTED tAttrValue.atFunction.
  OUTPUT CLOSE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bParse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bParse C-Win
ON CHOOSE OF bParse IN FRAME DEFAULT-FRAME /* Parse */
DO:
    DO WITH FRAME {&FRAME-NAME}:
        ASSIGN sourceFile keepNodes.
        RUN main.
        bRunNodeProc:SENSITIVE = keepNodes. 
        nodeProcedure:SENSITIVE = keepNodes.
    END. 
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bRunNodeProc
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bRunNodeProc C-Win
ON CHOOSE OF bRunNodeProc IN FRAME DEFAULT-FRAME /* Run code */
DO:
    ASSIGN FRAME {&FRAME-NAME} nodeProcedure.
    RUN runNodeProcedure.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME CFTreeView
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL CFTreeView C-Win OCX.NodeClick
PROCEDURE CFTreeView.TreeView.NodeClick .
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  Required for OCX.
    Node
  Notes:       
------------------------------------------------------------------------------*/
DEFINE INPUT PARAMETER p-Node AS COM-HANDLE NO-UNDO.

currentNode = INTEGER(ENTRY(2, p-Node:Key)).
currentNodeCount = INTEGER(ENTRY(3, p-Node:Key)).
{&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
RUN showSource(currentNodeCount).

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME nodeProcedure
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL nodeProcedure C-Win
ON RETURN OF nodeProcedure IN FRAME DEFAULT-FRAME
DO:
    APPLY 'CHOOSE':U TO bRunNodeProc.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME sourceFile
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL sourceFile C-Win
ON RETURN OF sourceFile IN FRAME DEFAULT-FRAME
DO:
  APPLY 'CHOOSE':u TO bParse.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.


/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
DO:
    APPLY "CLOSE":U TO parser.
    RUN disable_UI.
END.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

procedure LockWindowUpdate external "user32":
    def input parameter HWnd as long no-undo.
    def return parameter Result as long no-undo.
end procedure.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE control_load C-Win  _CONTROL-LOAD
PROCEDURE control_load :
/*------------------------------------------------------------------------------
  Purpose:     Load the OCXs    
  Parameters:  <none>
  Notes:       Here we load, initialize and make visible the 
               OCXs in the interface.                        
------------------------------------------------------------------------------*/

&IF "{&OPSYS}" = "WIN32":U AND "{&WINDOW-SYSTEM}" NE "TTY":U &THEN
DEFINE VARIABLE UIB_S    AS LOGICAL    NO-UNDO.
DEFINE VARIABLE OCXFile  AS CHARACTER  NO-UNDO.

OCXFile = SEARCH( "parsetree.wrx":U ).
IF OCXFile = ? THEN
  OCXFile = SEARCH(SUBSTRING(THIS-PROCEDURE:FILE-NAME, 1,
                     R-INDEX(THIS-PROCEDURE:FILE-NAME, ".":U), "CHARACTER":U) + "wrx":U).

IF OCXFile <> ? THEN
DO:
  ASSIGN
    chCFImageList = CFImageList:COM-HANDLE
    UIB_S = chCFImageList:LoadControls( OCXFile, "CFImageList":U)
    chCFTreeView = CFTreeView:COM-HANDLE
    UIB_S = chCFTreeView:LoadControls( OCXFile, "CFTreeView":U)
  .
  RUN initialize-controls IN THIS-PROCEDURE NO-ERROR.
END.
ELSE MESSAGE "parsetree.wrx":U SKIP(1)
             "The binary control file could not be found. The controls cannot be loaded."
             VIEW-AS ALERT-BOX TITLE "Controls Not Loaded".

&ENDIF

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE DisplayNode C-Win 
PROCEDURE DisplayNode :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER ParentTreeNode AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER TreeLevel AS INTEGER NO-UNDO.
  DEFINE INPUT PARAMETER theNode AS INTEGER NO-UNDO.
  DEFINE OUTPUT PARAMETER TreeNode AS CHARACTER NO-UNDO.

  DEFINE VARIABLE nodeType AS CHARACTER NO-UNDO.
  DEFINE VARIABLE child    AS INTEGER NO-UNDO.
  DEFINE VARIABLE nextChild AS INTEGER NO-UNDO.
  DEFINE VARIABLE ChildTreeNode AS CHARACTER NO-UNDO.
  DEFINE VARIABLE IDText AS CHARACTER  NO-UNDO.

  DEFINE VARIABLE ctrlNode AS COM-HANDLE  NO-UNDO.
  DEFINE VARIABLE ctrlChildNode AS COM-HANDLE  NO-UNDO.
  ASSIGN child = parserGetHandle().

  ASSIGN nodeType = parserNodeFirstChild(theNode,child).
  RUN printline (ParentTreeNode, TreeLevel, theNode, OUTPUT TreeNode, OUTPUT ctrlNode, OUTPUT IDText).
  DO WHILE nodeType <> "":
    /* If this is a new node head, run displayNode with it */
    IF parserNodeFirstChild(child, grandchild) <> "" 
    THEN RUN displayNode (TreeNode, TreeLevel + 1,  child, OUTPUT ChildTreeNode).
    ELSE DO:
        RUN printline (TreeNode, TreeLevel + 1, child, OUTPUT ChildTreeNode, OUTPUT ctrlChildNode, OUTPUT IDText).
        IF IDText <> ? 
        THEN DO:
            /* enhance with ID information TreeNode */
            /*ctrlNode:TEXT = SUBSTITUTE("&1 &2", ctrlNode:TEXT, IDText). */
            ctrlNode:TEXT = SUBSTITUTE("&3 &1 &2", parserGetNodeType(theNode), IDText, theNode).

        END.
    END.
    IF keepNodes 
    THEN ASSIGN nextchild = parserGetHandle().
    ELSE nextchild = child.
    ASSIGN nodeType = parserNodeNextSibling(child,nextchild).
    child = nextchild.
  END.
  IF NOT keepNodes 
  THEN parserReleaseHandle(child).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  RUN control_load.
  DISPLAY sourceFile keepNodes nodeProcedure sourceEditor 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  ENABLE sourceFile bParse keepNodes attrBrowse sourceEditor 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE Initialize-controls C-Win 
PROCEDURE Initialize-controls :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
def var LockSuccess as int no-undo.
    
 run LockWindowUpdate({&WINDOW-NAME}:hwnd, output LockSuccess).
 
do on error undo, LEAVE WITH FRAME {&FRAME-NAME}:
    /* *** Initialize TreeView Control **** */
    chCFTreeView:TreeView:LineStyle = 1. /* RootLines */
    chCFTreeView:TreeView:LabelEdit = 1. /* Manual */
    chCFTreeView:TreeView:Style = 7. /* Lines, plus/minus, image, and text */
    chCFTreeView:TreeView:ImageList = chCFImagelist:ImageList.
    chCFTreeViewNodes = chCFTreeView:TreeView:Nodes.
    sourceEditor:PROGRESS-SOURCE = YES.
    sourceEditor:WORD-WRAP = NO.
end.

process events.

if LockSuccess <> 0 then run LockWindowUpdate(0, output LockSuccess). 

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE main C-Win 
PROCEDURE main :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  DEFINE VARIABLE wasShowParserDirectives AS CHARACTER NO-UNDO.
  DEFINE VARIABLE TreeNode AS CHARACTER  NO-UNDO.

  ASSIGN wasShowParserDirectives = parserConfigGet("show-proparse-directives":U).
  IF showDirectives THEN
    parserConfigSet("show-proparse-directives":U, "true":U).
  ELSE
    parserConfigSet("show-proparse-directives":U, "false":U).
  SESSION:SET-WAIT-STATE("GENERAL").
  errorblock:
  DO ON ERROR UNDO, LEAVE:
    FILE-INFO:FILE-NAME = sourceFile.
    IF parserParse(FILE-INFO:FULL-PATHNAME) = FALSE THEN DO:
      MESSAGE parserErrorGetText() VIEW-AS ALERT-BOX ERROR TITLE "parserParse".
      LEAVE errorblock.
    END.
    chCFTreeViewNodes:Clear().
    EMPTY TEMP-TABLE tAttrValue.

    ASSIGN
      firstnode  = parserGetHandle()
      grandchild = parserGetHandle().
    parserNodeTop(firstnode).  /* gets us the "Program" node */
    /*
    chCFTreeViewNodes:Add(, 0, "ROOT,0,0", "ROOT", "DEFAULT", "DEFAULT").*/
    RUN displayNode ("", 1, firstnode, OUTPUT TreeNode).
  END. /* errorblock */
  parserConfigSet("show-proparse-directives":U, wasShowParserDirectives).
  SESSION:SET-WAIT-STATE("").
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PrintLine C-Win 
PROCEDURE PrintLine :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER ParentTreeNode AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER TreeLevel AS INTEGER    NO-UNDO.
  DEFINE INPUT PARAMETER theNode AS INTEGER NO-UNDO.
  DEFINE OUTPUT PARAMETER TreeNodeId AS CHARACTER  NO-UNDO.
  DEFINE OUTPUT PARAMETER Node AS COM-HANDLE  NO-UNDO.
  DEFINE OUTPUT PARAMETER IDText AS CHARACTER  NO-UNDO INIT ?.

  def buffer NewValue for tAttrValue.
      DEFINE VARIABLE iconString AS CHARACTER  NO-UNDO.

  DEFINE VARIABLE NodeText AS CHARACTER  NO-UNDO.
  CASE parserGetNodeType(theNode):
      WHEN "FIND" THEN IconString = "QUERY".
      OTHERWISE IconString = "DEFAULT".
  END CASE.
  ASSIGN
    NodeCount = NodeCount + 1
    NodeText = SUBSTITUTE("&3 &1 &2", parserGetNodeType(theNode), parserGetNodeText(theNode), theNode)
    TreeNodeId = SUBSTITUTE("&1,&2,&3", parserGetNodeType(theNode), theNode, nodecount) 
    .
  IF parserGetNodeType(theNode) = "ID" 
  THEN IDText = parserGetNodeText(theNode).
  IF treeLevel = 1 
  THEN node = chCFTreeViewNodes:Add(, 1, TreeNodeId, NodeText, iconString, iconString).
  ELSE node = chCFTreeViewNodes:Add(ParentTreeNode, 4, TreeNodeId, NodeText, iconString, iconString).
  IF NOT VALID-HANDLE(node)
  THEN MESSAGE 
     "error adding" TreeNodeId NodeText "to" SKIP
     ParentTreeNode
     VIEW-AS ALERT-BOX INFO BUTTONS OK.
  IF NOT CAN-FIND(FIRST tAttrValue WHERE tAttrValue.atNodeCount = nodeCount) 
  THEN DO:
      IF showDirectives 
      THEN DO:
          CREATE NewValue.
          ASSIGN
              NewValue.atValue = parserAttrGet(theNode, "proparsedirective":U)
              NewValue.atFunction = 'parserAttrGet(theNode, "proparsedirective":U)'
              NewValue.atNode = theNode
              NewValue.atNodeCount = nodeCount
              NewValue.atName = "proparsedirective"       
              NewValue.atLabel = "Proparse directive"
              .
      END.
      IF showLine OR showColumn 
      THEN DO:
          CREATE NewValue.
          ASSIGN
              NewValue.atValue = STRING(parserGetNodeLine(theNode)) 
                  + (IF showColumn THEN ":" + STRING(parserGetNodeColumn(theNode)) ELSE "")
              NewValue.atFunction = 'parserGetNodeLine(theNode)' 
                  + (IF showColumn THEN '":" + parserGetNodeColumn(theNode)' ELSE "")
              NewValue.atNode = theNode
              NewValue.atNodeCount = nodeCount
              NewValue.atName = "line"
              NewValue.atLabel = (IF ShowColumn THEN "line:column" ELSE "line")
              .
      END.
      IF showFile
      THEN DO:
          CREATE NewValue.
          ASSIGN
              NewValue.atValue = parserGetNodeFilename(theNode)
              NewValue.atFunction = 'parserGetNodeFilename(theNode)'
              NewValue.atNode = theNode
              NewValue.atNodeCount = nodeCount
              NewValue.atName = "filename"       
              NewValue.atLabel = "File name"
              .
      END.
      IF showFile
      THEN DO:
          CREATE NewValue.
          ASSIGN
              NewValue.atValue = parserAttrGet(theNode,"storetype":U)
              NewValue.atFunction = 'parserAttrGet(theNode,"storetype":U)'
              NewValue.atNode = theNode
              NewValue.atNodeCount = nodeCount
              NewValue.atName = "storetype"       
              NewValue.atLabel = "Store type"
              .
      END.
      IF showStatehead AND parserAttrGet(theNode, "statehead":U) <> ""
      THEN DO:
          CREATE NewValue.
          ASSIGN
              NewValue.atValue = parserAttrGet(theNode, "statehead":U)
              NewValue.atFunction = 'parserAttrGet(theNode, "statehead":U)'
              NewValue.atNode = theNode
              NewValue.atNodeCount = nodeCount
              NewValue.atName = "statehead"  
              NewValue.atLabel = "State head"
              .
      END.
      IF showstate2 AND parserAttrGet(theNode, "state2":U) <> ""
      THEN DO:
          CREATE NewValue.
          ASSIGN
              NewValue.atValue = parserAttrGet(theNode, "state2":U)
              NewValue.atFunction = 'parserAttrGet(theNode, "state2":U)'
              NewValue.atNode = theNode
              NewValue.atNodeCount = nodeCount
              NewValue.atName = "state2"     
              NewValue.atLabel = "State 2"
              .
      END.
  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE runNodeProcedure C-Win 
PROCEDURE runNodeProcedure :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    IF currentNode <> 0 
    THEN RUN VALUE(nodeProcedure) (parser, currentNode).
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE SetDispAttr C-Win 
PROCEDURE SetDispAttr :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER attrList AS CHARACTER NO-UNDO.
  ASSIGN
    showColumn     = CAN-DO(attrList, "column":U)
    showDirectives = CAN-DO(attrList, "proparsedirective":U)
    showFile       = CAN-DO(attrList, "filename":U)
    showLine       = CAN-DO(attrList, "linenum":U)
    showState2     = CAN-DO(attrList, "state2":U)
    showStatehead  = CAN-DO(attrList, "statehead":U)
    showStoretype  = CAN-DO(attrList, "storetype":U).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE setOutputFile C-Win 
PROCEDURE setOutputFile :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER p AS CHARACTER NO-UNDO.
  ASSIGN
    showWindow = FALSE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE setParseFile C-Win 
PROCEDURE setParseFile :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER p AS CHARACTER NO-UNDO.
  ASSIGN sourceFile = p.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE showSource C-Win 
PROCEDURE showSource :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER theNodeCount AS INTEGER    NO-UNDO.
    DEFINE VARIABLE NodeCountLine AS INTEGER    NO-UNDO.
    FIND tAttrValue 
        WHERE tAttrValue.atNodeCount = theNodeCount 
          AND tAttrValue.atName = "filename"
        NO-ERROR.
    IF AVAIL tAttrValue 
    THEN DO WITH FRAME {&FRAME-NAME}:
        IF tAttrValue.atValue <> currentSource 
        THEN DO:
            sourceEditor:READ-FILE(tAttrValue.atValue).
            currentSource = tAttrValue.atValue.
            currentLine = 0.
        END.
        FIND tAttrValue 
            WHERE tAttrValue.atNodeCount = theNodeCount 
              AND tAttrValue.atName = "line"
            NO-ERROR.
        IF AVAIL tAttrValue 
        THEN DO:
            NodeCountLine = INTEGER(ENTRY(1, tAttrValue.atValue, ":")).
            IF NodeCountLine <> currentLine AND NodeCountLine > 0
            THEN DO:
                sourceEditor:CURSOR-LINE = NodeCountLine.
                currentLine = NodeCountLine.
                sourceEditor:SET-SELECTION(
                    sourceEditor:CONVERT-TO-OFFSET (NodeCountLine, 1),
                    sourceEditor:CONVERT-TO-OFFSET (NodeCountLine + 1, 1)).
            END.
        END.

    END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

